/*
    GDAM - Geoff & Dave's Audio Mixer
    Copyright (C) 1999    Dave Benson, Geoff Matters.

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Lesser General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Lesser General Public License for more details.

    You should have received a copy of the GNU Lesser General Public
    License along with this library; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307  USA

    Contact:
        daveb@ffem.org <Dave Benson>
        geoff@ugcs.caltech.edu <Geoff Matters>
*/
#ifndef __GDAM_DEVICE_ALSA_H__
#define __GDAM_DEVICE_ALSA_H__

/*
 * A rudimentary hack at an alsa driver.
 *
 * Not functional yet.
 */

typedef struct _GdamDeviceALSA GdamDeviceALSA;

#include <gdam/gdamsink.h>


#ifdef __cplusplus
extern "C" {
#endif /* __cplusplus */


GtkType gdam_source_get_type();
#define GDAM_TYPE_DEVICE_ALSA        (gdam_device_alsa_get_type ())
#define GDAM_DEVICE_ALSA(obj)        (GTK_CHECK_CAST ((obj), GDAM_TYPE_DEVICE_ALSA, GdamDeviceAlsa))


typedef struct _GdamDeviceAlsa GdamDeviceAlsa;

struct _GdamDeviceAlsa {
	GdamSink		sink;
	int			device_fd;
	GPollFD			poll_fd;
	guint			source_id;
	void*                   alsa_handle;
};

GdamSink* gdam_device_alsa_new (gpointer      device_data,
                               const char*   device_name,
			       const char*   device_options);

#ifdef __cplusplus
}
#endif /* __cplusplus */

#endif
