/*
    GDAM - Geoff & Dave's Audio Mixer
    Copyright (C) 1999    Dave Benson, Geoff Matters.

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Lesser General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Lesser General Public License for more details.

    You should have received a copy of the GNU Lesser General Public
    License along with this library; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307  USA

    Contact:
        daveb@ffem.org <Dave Benson>
        geoff@ugcs.caltech.edu <Geoff Matters>
*/

#include "gdamsourcesequencer.h"

static void gdam_source_sequencer_init(GdamSourceSequencer* source_sequencer)
{
}

static int gdam_source_sequencer_read(GdamSource*        source,
                                      GdamSample*        buffer,
				      int                max_read)
{
	GSList* added = NULL;
	GdamSourceSequencer* seq = GDAM_SOURCE_SEQUENCER(source);
	GSList* at;
	GSList* starting = NULL;
	int start_time;
	int end_time;

	gdam_sample_zero(buffer, max_read);

	while (max_read > 0) {

	start_time = seq->position;
	end_time = start_time + max_read;
	if (seq->...) {
	}
	for (at = seq->next_sorted; at != NULL; at = at->next) {
		...
	}

	...
}

static GdamTime gdam_source_sequencer_get_position(GdamSource*      source)
{
	return GDAM_SOURCE_SEQUENCER(source)->position;
}

static gboolean gdam_source_sequencer_seek(GdamSource*       source,
                                           GdamTime*         offset,
					   int               whence)
{
	...
}

static void gdam_source_sequencer_class_init(GdamSourceClass* source_class)
{
	source_class->read = gdam_source_sequencer_read;
	source_class->seek = gdam_source_sequencer_seek;
	source_class->get_position = gdam_source_sequencer_get_position;
}

GtkType gdam_source_sequencer_get_type()
{
	static GtkType source_sequencer_type = 0;
	if (!source_sequencer_type) {
		static const GtkTypeInfo source_sequencer_info = {
			"GdamSourceSequencer",
			sizeof(GdamSourceSequencer),
			sizeof(GdamSourceSequencerClass),
			(GtkClassInitFunc) gdam_source_sequencer_class_init,
			(GtkObjectInitFunc) gdam_source_sequencer_init,
			/* reserved_1 */ NULL,
			/* reserved_2 */ NULL,
			(GtkClassInitFunc) NULL
		};
		GtkType parent = GDAM_TYPE_SOURCE;
		source_sequencer_type = gtk_type_unique(parent,
		                                 &source_sequencer_info);
	}
	return source_sequencer_type;
}
