/*
    GDAM - Geoff & Dave's Audio Mixer
    Copyright (C) 1999    Dave Benson, Geoff Matters.

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Lesser General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Lesser General Public License for more details.

    You should have received a copy of the GNU Lesser General Public
    License along with this library; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307  USA

    Contact:
        daveb@ffem.org <Dave Benson>
        geoff@ugcs.caltech.edu <Geoff Matters>
*/
#ifndef __GDAM_SYNTH_TWO_FIR_H_
#define __GDAM_SYNTH_TWO_FIR_H_

#include "gdamsynthfilter.h"

typedef struct _GdamSynthTwoFir GdamSynthTwoFir;
typedef struct _GdamSynthTwoFirClass GdamSynthTwoFirClass;

#ifdef __cplusplus
extern "C" {
#endif /* __cplusplus */

GtkType gdam_synth_two_fir_get_type();
#define GDAM_TYPE_SYNTH_TWO_FIR			(gdam_synth_two_fir_get_type ())
#define GDAM_SYNTH_TWO_FIR(obj)              (GTK_CHECK_CAST ((obj), GDAM_TYPE_SYNTH_TWO_FIR, GdamSynthTwoFir))
#define GDAM_SYNTH_TWO_FIR_CLASS(klass)      (GTK_CHECK_CLASS_CAST ((klass), GDAM_TYPE_SYNTH_TWO_FIR, GdamSynthTwoFirClass))
#define GDAM_IS_SYNTH_TWO_FIR(obj)           (GTK_CHECK_TYPE ((obj), GDAM_TYPE_SYNTH_TWO_FIR))
#define GDAM_IS_SYNTH_TWO_FIR_CLASS(klass)   (GTK_CHECK_CLASS_TYPE ((klass), GDAM_TYPE_SYNTH_TWO_FIR))

struct _GdamSynthTwoFirClass {
	GdamSynthFilterClass		synth_two_fir_class;
};
struct _GdamSynthTwoFir {
	GdamSynthFilter			synth_two_fir;

	/* output[n] = coeffs[0] * input[n]
	             + coeffs[1] * input[n-1]
		     + coeffs[2] * input[n-2]  */
	gdouble				coeffs[3];
	gdouble				last_samples[2];
};

#ifdef __cplusplus
}
#endif /* __cplusplus */

#endif
